<?php

//////////////////////////////////////////////////////////////
//===========================================================
// clone.php
//===========================================================
// SOFTACULOUS 
// Version : 4.2.8
// Inspired by the DESIRE to be the BEST OF ALL
// ----------------------------------------------------------
// Started by: Alons
// Date:       10th Jan 2009
// Time:       21:00 hrs
// Site:       http://www.softaculous.com/ (SOFTACULOUS)
// ----------------------------------------------------------
// Please Read the Terms of use at http://www.softaculous.com
// ----------------------------------------------------------
//===========================================================
// (c)Softaculous Inc.
//===========================================================
//////////////////////////////////////////////////////////////

if(!defined('SOFTACULOUS')){

	die('Hacking Attempt');

}

//The Install process
function __clone(){

global $__settings, $error, $software, $globals, $replace_data, $source_data;
	
	//Do we meet the Minimum software requirements
	__requirements();
	
	if(!empty($error)){
		return false;
	}
	
	$temp = parse_url($source_data['softurl']);
	$source_data['relativeurl'] = $temp['path'];
	
	$temp = parse_url($__settings['softurl']);
	$__settings['relativeurl'] = $temp['path'];
	$__settings['domhost'] = $temp['host'];	
	$__settings['protocol'] = $temp['scheme'];
	
	sclone_replace($replace_data, $__settings['softpath'].'/config.php', true);
	
	//sql
	$query = "SELECT `content` FROM `go_templates` WHERE `id`='1';";
	$result = sdb_query($query, $__settings['softdbhost'], $__settings['softdbuser'], $__settings['softdbpass'], $__settings['softdb']);
	$source = $result[0]['content'];
	
	soft_preg_replace('/Date(.*?)Message\-ID(.*?)\@(.*?)\>(.*?)\-\-\\r\\n/is', $source, $domhost, 3);
	$destination = str_replace($domhost,$__settings['domhost'],$source);
	
	$update = "UPDATE `go_templates` SET `content`='".$destination."' WHERE `id`='1';";
	sdb_query($update, $__settings['softdbhost'], $__settings['softdbuser'], $__settings['softdbpass'], $__settings['softdb']);
	
	if(sfile_exists($__settings['softpath'].'/.htaccess')){
		
		// If the installation is on root domain we need to change the below relative URL
		if(is_dom_root($source_data['softpath'])){
			$replace_data['RewriteBase \'/\''] = 'RewriteBase \''.$__settings['relativeurl'].'\'';
			$replace_data['RewriteBase /'] = 'RewriteBase '.$__settings['relativeurl'];
			
			$replace_data['RewriteRule ^webdav(.*)$ /modules/dav/files.php'] = 'RewriteRule ^webdav(.*)$ '.$__settings['relativeurl'].'/modules/dav/files.php';
			$replace_data['RewriteRule ^caldav(.*)$ /modules/caldav/calendar.php'] = 'RewriteRule ^caldav(.*)$ '.$__settings['relativeurl'].'/modules/caldav/calendar.php';
			$replace_data['RewriteRule ^carddav(.*)$ /modules/carddav/addressbook.php'] = 'RewriteRule ^carddav(.*)$ '.$__settings['relativeurl'].'/modules/carddav/addressbook.php';
			$replace_data['RewriteRule ^Microsoft-Server-ActiveSync(.*)$ /modules/z-push/index.php'] = 'RewriteRule ^Microsoft-Server-ActiveSync(.*)$ '.$__settings['relativeurl'].'/modules/z-push/index.php';
		}elseif(is_dom_root($__settings['softpath'])){
			$replace_data['RewriteBase \''.$source_data['relativeurl'].'\''] = 'RewriteBase \'/\'';
			$replace_data['RewriteBase '.$source_data['relativeurl']] = 'RewriteBase /';
			
			$replace_data['RewriteRule ^webdav(.*)$ '.$source_data['relativeurl'].'/modules/dav/files.php'] = 'RewriteRule ^webdav(.*)$ /modules/dav/files.php';
			$replace_data['RewriteRule ^caldav(.*)$ '.$source_data['relativeurl'].'/modules/caldav/calendar.php'] = 'RewriteRule ^caldav(.*)$ /modules/caldav/calendar.php';
			$replace_data['RewriteRule ^carddav(.*)$ '.$source_data['relativeurl'].'/modules/carddav/addressbook.php'] = 'RewriteRule ^carddav(.*)$ /modules/carddav/addressbook.php';
			$replace_data['RewriteRule ^Microsoft-Server-ActiveSync(.*)$ '.$source_data['relativeurl'].'/modules/z-push/index.php'] = 'RewriteRule ^Microsoft-Server-ActiveSync(.*)$ /modules/z-push/index.php';
		}
		
		sclone_replace($replace_data, $__settings['softpath'].'/.htaccess', true);		
	}
	
	@srm($__settings['softpath'].'/tmp/cache/');
	@srm($__settings['softpath'].'/tmp/diskcache/');
	@srm($__settings['softdatadir'].'/cache/');
	
	@smkdir($__settings['softdatadir'].'/cache/', $globals['odc']);
	
	schmod($__settings['softpath'].'/tmp/', $globals['odc'],1);
	schmod($__settings['softdatadir'].'/', $globals['odc'],1);
}

//Check whether the Minimum Software configuration matches
function __requirements(){

global $__settings, $error, $software;
	
	return true;

}

?>